using Library;
using MySystem.PxcModels;
using System;
using System.Linq;

namespace MySystem
{
    public class UserLoginRecordHelper
    {
        public readonly static UserLoginRecordHelper Instance = new UserLoginRecordHelper();
        private UserLoginRecordHelper()
        { }

        public string Start()
        {
            bool op = true;
            WebCMSEntities db = new WebCMSEntities();
            string result = "";
            int total = 0;
            while (op)
            {
                UserLoginRecord PopData = new UserLoginRecord();
                try
                {
                    //获取apserver待同步的数据，执行入库
                    PopData = RedisDbconn.Instance.RPop<UserLoginRecord>("Pop:UserLoginRecord");
                    if (PopData != null)
                    {
                        // UserLoginRecord checkExist = db.UserLoginRecord.FirstOrDefault(m => m.Id == PopData.Id);
                        // if (checkExist != null)
                        // {
                        //     checkExist = PopData;
                        // }
                        // else
                        // {
                            db.UserLoginRecord.Add(PopData);
                        // }
                        if (total >= 20)
                        {
                            total = 0;
                            db.SaveChanges();
                        }
                        if (string.IsNullOrEmpty(result)) result = "success";
                    }
                    else
                    {
                        db.SaveChanges();
                        op = false;
                    }
                }
                catch (Exception ex)
                {
                    ErrorMsg msg = new ErrorMsg();
                    msg.Obj = PopData;
                    msg.Time = DateTime.Now;
                    msg.ErrorContent = ex.ToString();
                    Utils.WriteLog(Newtonsoft.Json.JsonConvert.SerializeObject(msg), "Pop:UserLoginRecord:Error");
                    result = "有异常，请查看Pop:UserLoginRecord:Error队列";
                }
            }
            db.Dispose();
            return result;
        }
    }
}